\existentialConstants {
  int a, b, z;
}

\predicates {
  in32(int);
}

\functions {
  \partial \relational int add32(int, int);
  \partial \relational int sub32(int, int);
  \partial \relational int minus32(int);
  \partial \relational int shift32(int, int);

  \partial \relational int and(int, int);
  \partial \relational int bitneg(int);
  \partial \relational int or(int, int);
}

\problem {

  \forall int x; (in32(x) -> x >= -2*1024*1024*1024 & x < 2*1024*1024*1024)
->
// Commented, because this will in general cause nontermination
//  \forall int x; (x >= -2*1024*1024*1024 & x < 2*1024*1024*1024 -> in32(x))
//->

// Signed 32-bit addition

  \forall int x, y, res; {add32(x, y)} (
    add32(x, y) = res ->
    \exists int k; res = x + y + k * 4*1024*1024*1024 &
    in32(res)
  )
->

// Signed 32-bit subtraction

  \forall int x, y; {sub32(x, y)} sub32(x, y) = add32(x, -y)
->

// Signed 32-bit negation

  \forall int x; {minus32(x)} minus32(x) = add32(0, -x)
->

// Bit-shifts to the left or right

  \forall int x; {shift32(x, 0)} shift32(x, 0) = x
->
  \forall int x, y, res; {shift32(x, y)}
      (y > 0 -> shift32(x, y) = res ->
       \exists int k;
         res = shift32(x, y-1) * 2 + k * 4*1024*1024*1024 &
       in32(res))
->
  \forall int x, y, res; {shift32(x, y)}
      (y < 0 -> shift32(x, y) = res ->
       \exists int k, m; (
         m >= 0 & m <= 1 &
         x = 2*k + m & res = shift32(k, y+1)
       ))
->


// Bit-wise negation

  \forall int x; {bitneg(x)} bitneg(x) = -x - 1
->

// Bit-wise and. This mainly does a case analysis over the second
// argument, which means that it is usually more
// efficient to have constant values as the second argument

  \forall int x; {and(x, 0)} and(x, 0) = 0
->
  \forall int x; {and(x, -1)} and(x, -1) = x
->
  \forall int x, y, res; {and(x, y)}
      ((y >= 1 | y <= -2) -> and(x, y) = res ->
       \exists int k, l, m, n; (
         x = 2*k + m & y = 2*l + n & m >= 0 & m <= 1 & (
           n = 0 & res = and(k, l) * 2
           |
           n = 1 & res = and(k, l) * 2 + m
       )))
->

// Bit-wise or

  \forall int x, y; {or(x, y)} or(x, y) = -and(-x-1, -y-1) - 1
->

/*
  in32(a) & b >= -1 & b <= 1 &
  z = shift32(a, b) */

  in32(a) & in32(b) &
  z = or(a, 3)
->
  false
}
