/**
 Find a linear ranking function for the program

 
typedef long LONG;

int main(void)
{
  LONG l_var;

  __CPROVER_assume(l_var < 0);

  while (l_var > -1073741824)
  {
    ;
    l_var = l_var << 1;
  }

  return 0;
}

 in 32-bit arithmetic 
 */

\existentialConstants {
  // the lambda-witness vectors

  int l_11_1;
  int l_11_2;
  int l_11_3;
  int l_11_4;
  int l_11_5;
  int l_11_6;
  int l_11_7;

  int l_12_1;
  int l_12_2;
  int l_12_3;
  int l_12_4;
  int l_12_5;
  int l_12_6;
  int l_12_7;

  int l_21_1;
  int l_21_2;
  int l_21_3;
  int l_21_4;
  int l_21_5;
  int l_21_6;
  int l_21_7;

  int l_22_1;
  int l_22_2;
  int l_22_3;
  int l_22_4;
  int l_22_5;
  int l_22_6;
  int l_22_7;

  int rankingCoeff1;
  int rankingCoeff2;
}

\problem {
  
//   l_i1 Ai' = 0

  l_11_1 * 0 + l_11_2 * 0 + l_11_3 * -1 + l_11_4 * 1 + l_11_5 * -2 + l_11_6 * 2 + l_11_7 * -1 = 0
&
  l_21_1 * 0 + l_21_2 * 0 + l_21_3 * -1 + l_21_4 * 1 + l_21_5 * -2 + l_21_6 * 2 + l_21_7 * -1 = 0
&

//   (l_i1 - l_i2) Ai = 0

  (l_11_1 - l_12_1) * -1 + (l_11_2 - l_12_2) * 1 + (l_11_3 - l_12_3) * 0 +
  (l_11_4 - l_12_4) * 0 + (l_11_5 - l_12_5) * 1 + (l_11_6 - l_12_6) * -1 +
  (l_11_7 - l_12_7) * 0 = 0
&  
  (l_21_1 - l_22_1) * -1 + (l_21_2 - l_22_2) * 1 + (l_21_3 - l_22_3) * 0 +
  (l_21_4 - l_22_4) * 0 + (l_21_5 - l_22_5) * 1 + (l_21_6 - l_22_6) * -1 +
  (l_21_7 - l_22_7) * 0 = 0
&  

//   l_i2 (Ai + Ai') = 0

  l_12_1 * (-1 + 0) + l_12_2 * (1 + 0) + l_12_3 * (0 + -1) + l_12_4 * (0 + 1) +
  l_12_5 * (1 + -2) + l_12_6 * (-1 + 2) + l_12_7 * (0 + -1) = 0
&
  l_22_1 * (-1 + 0) + l_22_2 * (1 + 0) + l_22_3 * (0 + -1) + l_22_4 * (0 + 1) +
  l_22_5 * (1 + -2) + l_22_6 * (-1 + 2) + l_22_7 * (0 + -1) = 0
&

//   l_i2 bi < 0

  l_12_1 * 2147483648 + l_12_2 * -1 + l_12_3 * 2147483648 + l_12_4 * -1 +
  l_12_5 * 0 + l_12_6 * 0 + l_12_7 * 1073741823 < 0
&
  l_22_1 * 2147483648 + l_22_2 * 2147483647 + l_22_3 * 2147483648 + l_22_4 * 2147483647 +
  l_22_5 * (-4294967296) + l_22_6 * (4294967296) + l_22_7 * 1073741823 < 0
&

//   l_12 A1' = l_22 A2'

  rankingCoeff1 = l_12_1 * 0 + l_12_2 * 0 + l_12_3 * -1 + l_12_4 * 1 + l_12_5 * -2 + l_12_6 * 2 + l_12_7 * -1
&
  rankingCoeff2 = l_22_1 * 0 + l_22_2 * 0 + l_22_3 * -1 + l_22_4 * 1 + l_22_5 * -2 + l_22_6 * 2 + l_22_7 * -1
&
  rankingCoeff1 = rankingCoeff2
&

//   l_s non-negative

  l_11_1 >= 0 &
  l_11_2 >= 0 &
  l_11_3 >= 0 &
  l_11_4 >= 0 &
  l_11_5 >= 0 &
  l_11_6 >= 0 &
  l_11_7 >= 0 &
  l_12_1 >= 0 &
  l_12_2 >= 0 &
  l_12_3 >= 0 &
  l_12_4 >= 0 &
  l_12_5 >= 0 &
  l_12_6 >= 0 &
  l_12_7 >= 0 &
  l_21_1 >= 0 &
  l_21_2 >= 0 &
  l_21_3 >= 0 &
  l_21_4 >= 0 &
  l_21_5 >= 0 &
  l_21_6 >= 0 &
  l_21_7 >= 0 &
  l_22_1 >= 0 &
  l_22_2 >= 0 &
  l_22_3 >= 0 &
  l_22_4 >= 0 &
  l_22_5 >= 0 &
  l_22_6 >= 0 &
  l_22_7 >= 0
}